/*
 *	@filename	letv_common.js
 *	@depends	jquery 1.4.2
 *	@Author		guewool@163.com.
 *	@employer	letv.com.
 *	@create		2011-02
 *	@updata		2011-03-29
 */
(function(jQuery) { 
/**
 * jQuery Plugin to obtain touch gestures from iPhone, iPod Touch and iPad, should also work with Android mobile phones (not tested yet!)
 * Common usage: wipe images (left and right to show the previous or next image)
 * 
 * @author Andreas Waltl, netCU Internetagentur (http://www.netcu.de)
 * @version 1.0 (15th July 2010)
 */
   jQuery.fn.touchwipe = function(settings) {
     var config = {
    		min_move_x: 20,
 			wipeLeft: function() { alert("left"); },
 			wipeRight: function() { alert("right"); },
			preventDefaultEvents: true
	 };
     
     if (settings) jQuery.extend(config, settings);
 
     this.each(function() {
    	 var startX;
		 var isMoving = false;

    	 function cancelTouch() {
    		 this.removeEventListener('touchmove', onTouchMove);
    		 startX = null;
    		 isMoving = false;
    	 }	
    	 
    	 function onTouchMove(e) {
    		 if(config.preventDefaultEvents) {
    			 e.preventDefault();
    		 }
    		 if(isMoving) {
	    		 var x = e.touches[0].pageX;
	    		 var dx = startX - x;
	    		 if(Math.abs(dx) >= config.min_move_x) {
	    			cancelTouch();
	    			if(dx > 0) {
	    				config.wipeLeft();
	    			}
	    			else {
	    				config.wipeRight();
	    			}
	    		 }
    		 }
    	 }
    	 
    	 function onTouchStart(e){
    		 if (e.touches.length == 1) {
    			 startX = e.touches[0].pageX;
    			 isMoving = true;
    			 this.addEventListener('touchmove', onTouchMove, false);
    		 }
    	 }
		//this.addEventListener('touchstart', onTouchStart, false);
     });
     return this;
   };
 
 })(jQuery);

var Slider3D = function(){
	var init = function(config){
		this.config = config||{};
		this.parent = jQuery(this.config.id);
		this.screnW = parseInt(this.parent.find("ul").css("width"));
		this.maxW = this.config.maxW;
		this.minW = this.config.minW;
		this.lbtn = this.config.lbtn;
		this.rbtn = this.config.rbtn;
		this.perL = 0;
		this.item = this.parent.find("li");
		this.length = this.item.length;
		this.curr = 0;
		this.delay= config.delay;
	};
	
	init.prototype = {
		pos : function(n){
			var _self = this;
			_self.item.each(function(i){
				var curr = _self.curr;
				if(curr == n) return;
				
				var w = ( i==n )?_self.maxW : _self.minW;
				var deltaLeft = _self.maxW-_self.minW;
				var m = Math.abs(_self.curr-n);
				
				var perL = _self.perL*m;
				if(n>curr){
					var p = "-=";
					var l= (i>curr && i==n) ? perL+ deltaLeft :perL;
				}else{
					var p = "+=";
					var l= (i==curr) ? perL+ deltaLeft : perL;
				}
				
				var span = jQuery(this).find("span");
				var a = jQuery(this).find("a");
				
				if( n<i && i<_self.curr || n>i && i>_self.curr){
					l+=deltaLeft; 
					var valL = (n>i)?"transparent dashed "+w+"px":"transparent dashed 0";
					var valR = (n<i)?"transparent dashed "+w+"px":"transparent dashed 0";
					span.css({borderLeft:valL, borderRight:valR})
				}
				
				var z = -20 * Math.abs(i-n) +200;
				_self.move(jQuery(this),w,p+l,z);
				
				var delay = _self.delay;
				if(i==n){
					var borStyle, p;
					if(n>curr){
						p={"left":"0pt","right":"auto"};
						borStyle={borderTopWidth:0, borderBottomWidth:0, borderLeftWidth:0, borderRightWidth:w };
					}else if(n<curr){
						p={"left":"auto","right":"0pt"};
						borStyle={borderTopWidth:0, borderBottomWidth:0, borderLeftWidth:w, borderRightWidth:0 };
					}
					var tit = jQuery(this).find("div");
					jQuery(this).find("img").css({"opacity":1});
					span.animate( borStyle,delay,function(){
						span.css("borderStyle","solid solid");
						_self.hrefable(a,1);
						tit.css("opacity",1).fadeIn();
					}).css(p);
				}
				if( Math.abs(_self.curr-n)>1 ){					
					if( n<i && i<_self.curr ){
						var span = jQuery(this).find("span");
						span.get(0).style.cssText += "";
						span.get(1).style.cssText += "";
					}
					if( n>i && i>_self.curr ){
						var span = jQuery(this).find("span");
						span.get(0).style.cssText += "";
						span.get(1).style.cssText += "";
					}
				}
				if(i==curr){
					jQuery(this).find("div.Tvtxt").stop().fadeOut();
					jQuery(this).find("img").css({"opacity":0.6});
					if(n>curr){
						span.css("borderStyle","solid solid solid dashed");
						span.css({borderLeftWidth:_self.maxW, borderRightWidth:0})
						span.eq(0).animate({borderTopWidth:40, borderLeftWidth:_self.minW}, delay);
						span.eq(1).animate({borderBottomWidth:40, borderLeftWidth:_self.minW}, delay);
					}
					if(n<curr){
						span.css("borderStyle","solid dashed solid solid");
						span.css({borderLeftWidth:0, borderRightWidth:_self.maxW})
						span.eq(0).animate({borderTopWidth:40, borderRightWidth:_self.minW}, delay);
						span.eq(1).animate({borderBottomWidth:40, borderRightWidth:_self.minW}, delay);
					}
					_self.hrefable(a,0);
				}
			});
			_self.curr=n;
			//jsDebug.info("curr: "+_self.curr)
		},
		hrefable : function(item,n){
			if(n==1){
				item.attr("href",item.data("url"));
			}else{
				item.data("url",item.attr("href"));
				item.attr("href","javascript:;");
			}
		},
		move : function(item,w,l,z){
			var delay = this.delay;
			item.animate({width:w, left:l},delay).css("zIndex",z);
		},
		toleft:function(){
			var _self = this;
			var m = (_self.curr+_self.length-1)%_self.length;
			
			_self.pos( m )
		},
		toright:function(){
			var _self = this;
			var m = (_self.curr+_self.length+1)%_self.length;
			
			_self.pos( m )
		},
		initPos:function(){
			var _self = this;
			var perL = parseInt( (_self.screnW - _self.maxW)/2/(_self.length-1) );
			var radian = perL/3;
			var blank= Math.floor(_self.length/2);
			_self.curr = blank;
			_self.perL = perL;
			
			_self.item.each(function(i){
				var lefts = (i>blank)?perL*(i+blank)+(_self.maxW-_self.minW) : perL*(i+blank);
				var w = blank==i?_self.maxW : _self.minW;
				var z = -1 * Math.abs(i-blank) +200;
				//var z = 20 * Math.abs(i-blank) +200;
				var bder = (i>_self.curr)?"borderRightWidth":"borderLeftWidth";
				jQuery(this).animate({left:lefts,width:w},800, function(){
					_self.item.css({"opacity":1, 'background':'#000'}).find("div:eq(0)").fadeIn().find("img").css("opacity",0.6);
					_self.item.eq(_self.curr).find("img").css({"opacity":1}).end().find("div").show();
				}).css("zIndex",z).bind("click",function(){
					_self.pos(i);
				}).find("span").css(bder,w);
				var a = jQuery(this).find("a");
				_self.hrefable(a,0);
				if(i==_self.curr) a.attr("href",a.data("url"));
			});
			
			jQuery(_self.lbtn).find("a").attr("href","javascript:;").click(function(){
				_self.toleft();
				return false;
			});
			jQuery(_self.rbtn).click(function(){
				_self.toright();
				return false;
			}).find("a").attr("href","javascript:;");
		}
	};
	
	return init;
}()

//===================================//
function SwitchOver(box,character,delay){
	this.box = box;
	var character = character||{};
	this.films = box.find(character.films);
	this.clips = box.find(character.clips);
	this.btns = box.find(character.btns);
	this.max = this.films.find("li").length;
	this.per = 0;
	// this.per = parseInt(this.films.find("li").height());
	this.rs = 0;
	this.t,this.d;
	this.delay = delay||3000;
	this.init = function(){
		//派生类扩展用
	}
	this.acted = function(n){
		//派生类扩展用
	}
	this.hrefAble = function(n){
		var _self = this;
		var a = _self.films.find("li>a");
		if(n=="init"){
			for(var i=0; i<_self.max; i++){
				var item = a.eq(i);
				item.data("url",item.attr("href")).attr("href","javascript:;");
			}
		}else if(typeof n =="number"){
			a.attr("href","javascript:;");
			a.eq(n).attr("href",a.eq(n).data("url"));
		}
	}
	this.autoPlay = function(){
		var _self=this;
		_self.t = setInterval(function(){
			_self.rs+=1;
			_self.rs%=_self.max;
			_self.acted();
		},_self.delay);
	}
	this.thumbBtns = function(){
		var _self = this;
		_self.clips.each(function(i){
			jQuery(this).hover(function(){ _self.acted(i) },function(){ _self.autoPlay();});
		})
	};
	this.siblingShow = function(i){
		var _self=this;
		clearInterval(this.t);
		_self.autoPlay();
		var p=_self.rs;
		if(i){
			p+=1;
		}else{
			p-=1;
		}
		if(p<0) p+=_self.max;
		else if(p>=_self.max) p-=_self.max;
		_self.rs =p;
		_self.acted();
		return false;
	};
	
}

//=====================================//
function SliderTop(box,character, delay){
	this.method = SwitchOver;
	this.method(box,character, delay);
	delete this.method;
	this.per = parseInt(this.films.find("li").height());
	this.init = function(){
		var _self = this;
		clearInterval(this.t);
		
		_self.autoPlay();
		_self.thumbBtns();
		
		_self.btns.each(function(i){
			jQuery(this).click(function(){_self.siblingShow(i)});
		})
	}
	this.acted = function(n){
		var _self=this;
		if(n>-1){
			clearInterval(_self.t);
			if( n==_self.rs ) return;
			_self.rs=n;
		}
		_self.clips.siblings(".on").removeClass("on");
		var t = _self.rs*_self.per;
		
		_self.films.stop().animate({top:"-"+t+"px"},300, "swing");
		_self.clips.eq(_self.rs).addClass("on");
	}
	this.init();
}
//=====================================//
function SliderLeft(box,character,type,delay){
	this.method = SwitchOver;
	this.method(box,character, delay);
	delete this.method;
	this.init = function(){
		var _self = this;
		_self.per = parseInt(_self.films.find("li").width());
		clearInterval(this.t);
		_self.cloneItem();
		//_self.hrefAble("init");
		
		_self.autoPlay();
		_self.thumbBtns();
		_self.btns.each(function(i){
			jQuery(this).click(function(){_self.siblingShow(i)});
		})
	}
	this.acted = function(n){
	
		var _self=this;
		if(n>-1){
			clearInterval(_self.t);
			if( n==_self.rs ) return;
			_self.rs=n;
		}
		_self.clips.siblings(".on").removeClass("on");
		_self.per=332;
		var t = _self.rs*_self.per;
		
		_self.films.stop().animate({ left:"-"+t+"px"},500, "swing", function(){
			//_self.hrefAble( (_self.rs+1) % _self.max );
			jQuery("#screen").css({"background":"#000"}).html( _self.films.find("li").eq( _self.rs+1).html() ).find("a").hide().fadeIn();
		});
		_self.clips.eq(_self.rs).addClass("on");
	}
	this.cloneItem= function(){
		var _self = this;
		var s = _self.films.html();
		_self.films.append(s);
		_self.films.prepend(_self.films.find("li:last-child"));
	};
	
	this.init();
}

//=====================================//
function SliderRing(box,character,type,delay){
	this.method = SwitchOver;
	this.method(box,character, 3000);
	delete this.method;
	this.styles = [];
	this.rs = 2;
	this.last=2;
	
	this.init = function(){
		var _self = this;
		_self.getPosition();
		_self.hrefAble("init");
		
		_self.autoPlay();
		_self.thumbBtns();
		_self.btns.each(function(i){
			jQuery(this).click(function(){_self.acted(i)});
		})
	}
	this.acted = function(n){
		var _self=this; 
		if(n>-1){
			clearInterval(_self.t);
			if( n==_self.rs ) return;
			_self.rs=n;
		}
		var rs = _self.rs, d;
		d = Math.floor(_self.max/2) - rs;
			
		_self.films.find("li").each(function(i){
			var th = jQuery(this);
			
			th.find(".DMtxt").hide();
			th.stop().animate( _self.styles[(i+_self.max+d) % _self.max], 800, "swing", function(){
				_self.hrefAble( rs );
				if(i==rs) th.find(".DMtxt").fadeIn();
			});
			var dx = Math.abs( i - _self.rs), m;
			if(rs==i) m=2;
			else if(dx==1 || dx==4) m=1;
			else m=0;
			
			setTimeout(function(){
				th.css("zIndex",10*m);
				th.find("a img").css("opacity",0.4)
				if(i==rs) th.find("a img").css("opacity",1); //Math.floor(_self.max/2)))
			},150);
		});
		
		_self.clips.siblings(".on").removeClass("on");
		_self.clips.eq(_self.rs).addClass("on");
	};
	
	this.getPosition= function(){
		var _self = this;
		_self.films.find("li").each(function(){
			var th = jQuery(this);
			_self.styles.push({
				width:parseInt(th.css("width")),
				height:parseInt(th.css("height")),
				left:parseInt(th.css("left")),
				top:th.css("top")
			});
		})
	};
	
	this.init();
}

//=====================================//
function fadeShow(box,character,delay){
	this.method = SwitchOver;
	this.method(box,character,delay);
	delete this.method;
	this.init = function(){
	
		var _self = this;
		clearInterval(this.t);
		_self.autoPlay();
		_self.thumbBtns();
		
	}
	this.acted= function(n){
		var _self=this;
		
		if(n>-1){
			clearInterval(_self.t);
			if( n==_self.rs ) return;
			_self.rs=n;
		}
		_self.clips.siblings(".on").removeClass("on");
		
		var li = _self.films.find("li");
		li.stop().css("opacity",1).hide();
		li.eq(_self.rs).fadeIn(function(){
			var bg = jQuery(this).find(".class").show();
			var bg = jQuery(this).find(".class").css("opacity",0.7);
		});
		_self.clips.eq(_self.rs).addClass("on");
	};
	this.init();
}
var EchoHtml={
	nindex : function(config){	
		jQuery.getJSON(config.url,function(data){
			var screenbuf = ["<div class=\"focusbox\" > <div class=\"fpic\"><ul> "];
			var contrbuf = ["<div class=\"fmenu\"> "+
				"<a href=\"javascript:;\" class=\"btn_pre\" ></a> "+
				"<ul>"];
			
			jQuery.each(data, function(i,item){
				var items = data[i];
				//screen.find(" ")
				screenbuf.push("<li>"+
				"<div class=\"Fimg\"><a href="+ item.titleurl +" target=\"_blank\"><img src="+item.titlepic+" /></a></div> "+
					"<div class=\"Ftxt\">"+
					"<h1><a href="+ item.titleurl +" target=\"_blank\">"+ item.title +"</a></h1> "+
					"<p><a href="+ item.titleurl +" target=\"_blank\">"+ item.smalltext +"</a></p> "+
					"</div>"+
				"</li>");
				cls= ( i == config.sel )? "class=\"on\"" : "";
				contrbuf.push("<li "+cls+"><img src=" +item.titlepic+" /></li> ");
				
				
			});
			screenbuf.push("</ul> </div> ");
			contrbuf.push("</ul> <a href=\"javascript:;\" class=\"btn_next\" ></a> </div>	 </div>");
			jQuery(config.box).html(screenbuf.join("\n") + contrbuf.join("\n"));
			var ani = new SliderTop(jQuery("#focusbox"), {films:".fpic ul", clips:".fmenu li",btns:".fmenu a"} );
			jQuery("#focusbox").touchwipe({
				wipeLeft: function() {
					ani.siblingShow(1);
				},
				wipeRight: function() {
					ani.siblingShow(0);
				}
			});
		});
		
			
		
	}
}
